/*******************************************************************************
 * @file descriptors.c
 * @brief USB descriptors.
 *******************************************************************************/

//=============================================================================
// src/descriptors.c: generated by Hardware Configurator
//
// This file is only generated if it does not exist. Modifications in this file
// will persist even if Configurator generates code. To refresh this file,
// you must first delete it and then regenerate code.
//
// MODS ASP 2019-04-04
//=============================================================================
//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <si_toolchain.h>
#include <endian.h>
#include <stdlib.h>
#include <string.h>
#include <efm8_usb.h>
#include "descriptors.h"
#include <usb_audio.h>
#include <usb_midi.h>

#ifdef __cplusplus
extern "C" {
#endif

/*
 * This is the Device Descriptor.
 */
SI_SEGMENT_VARIABLE(deviceDesc[],
		const USB_DeviceDescriptor_TypeDef,
		SI_SEG_CODE) =
{
	USB_DEVICE_DESCSIZE,            // bLength
	USB_DEVICE_DESCRIPTOR,			// bDescriptorType
	htole16(0x0200),				// bcdUSB
	0,								// bDeviceClass
	0,								// bDeviceSubClass
	0,								// bDeviceProtocol
	64,								// bMaxPacketSize
	USB_VENDOR_ID,					// idVendor
	USB_PRODUCT_ID,					// idProduct
	htole16(0x0100),				// bcdDevice
	1,								// iManufacturer
	2,								// iProduct
	3,								// iSerialNumber
	1,								// bNumConfigurations
};

// It would be nice if Keil C51 was C99 compliant!
SI_SEGMENT_VARIABLE(configDesc[],
		const USB_ConfigDesc_t,
		SI_SEG_CODE) =
{
		// .Config_Header = {
				USB_CONFIG_DESCSIZE,		// bLength
				USB_CONFIG_DESCRIPTOR,		// bDescriptorType
				htole16(0x0085),			// wTotalLength, 133 bytes
				2,							// bNumInterfaces
				1,							// bConfigurationValue
				4,							// iConfiguration
				CONFIG_DESC_BM_RESERVED_D7, // bmAttributes
				CONFIG_DESC_MAXPOWER_mA(100), // bMaxPower

		// .AC_Standard_IF_Desc = {
				USB_INTERFACE_DESCSIZE,		// bLength
				USB_INTERFACE_DESCRIPTOR,	// bDescriptorType
				0,							// bInterfaceNumber, should make this a #define
				0,							// bAlternateSetting
				0,							// bNumEndpoints, this interface uses the control endpoint
				USB_CLASS_AUDIO,			// bInterfaceClass
				USB_AUDIO_AUDIOCONTROL,		// bInterfaceSubClass
				0,							// bInterfaceProtocol
				5,							// iInterface

		// .AC_CS_IF_Desc = {
				sizeof(USB_MIDI_CS_AC_IF_Descriptor_t),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,	// bDescriptorType
				MIDI_CS_IF_HEADER,				// bDescriptorSubtype
				htole16(0x0100),				// bcdADC
				htole16(0x0009),				// wTotalLength
				1,								// bInCollection
				1, 								// baInterfaceNr

//		.MS_Standard_IF_Desc = {
				USB_INTERFACE_DESCSIZE,		// bLength
				USB_INTERFACE_DESCRIPTOR,	// bDescriptorType
				1,							// bInterfaceNumber, should make this a #define
				0,							// bAlternateSetting
				2,							// bNumEndpoints
				USB_CLASS_AUDIO,			// bInterfaceClass
				USB_AUDIO_MIDISTREAMING,	// bInterfaceSubClass
				0,							// bInterfaceProtocol
				6,							// iInterface

		// .MS_CS_IF_Desc = {
				sizeof(USB_MIDI_CS_MS_IF_Descriptor_t),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,			// bDescriptorType
				MIDI_CS_IF_HEADER,						// bDescriptorSubtype
				htole16(0x0100),						// BcdADC
				htole16(0x0061),						// wTotalLength

		// .Jack_1 = {
				sizeof(USB_MIDI_In_Jack_Descriptor_t),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,			// bDescriptorType
				MIDI_CS_IF_IN_JACK,						// bDescriptorSubtype
				MIDI_JACKTYPE_Embedded,					// bJackType
				JACK1_EMBIN,							// bJackID constant identifying this Jack within the function
				0,										// iJack index of a string descriptor describing this jack

		// .Jack_2 = {
				USB_MIDI_OUT_JACK_DESCRIPTOR_SIZE(1),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,			// bDescriptorType
				MIDI_CS_IF_OUT_JACK,					// bDescriptorSubtype
				MIDI_JACKTYPE_External,					// bJackType
				JACK2_EXTOUT,							// bJackID
				1,										// bNrInputPins
				JACK1_EMBIN,							// baSourceID
				1,										// baSourcePin
				0,										// iJack

		// .Jack_3 = {
				sizeof(USB_MIDI_In_Jack_Descriptor_t),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,			// bDescriptorType
				MIDI_CS_IF_IN_JACK,						// bDescriptorSubtype
				MIDI_JACKTYPE_External,					// bJackType
				JACK3_EXTIN,							// bJackID constant identifying this Jack within the function
				0,										// iJack, index of a string descriptor describing this jack

			// .Jack_4 = {
				USB_MIDI_OUT_JACK_DESCRIPTOR_SIZE(1),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,			// bDescriptorType
				MIDI_CS_IF_OUT_JACK,					// bDescriptorSubtype
				MIDI_JACKTYPE_Embedded,					// bJackType
				JACK4_EMBOUT,							// bJackID
				1,										// bNrInputPins
				JACK3_EXTIN,							// baSourceID
				1,									// baSourcePin
				0,										// iJack

			// .Jack_5 = {
				sizeof(USB_MIDI_In_Jack_Descriptor_t),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,			// bDescriptorType
				MIDI_CS_IF_IN_JACK,						// bDescriptorSubtype
				MIDI_JACKTYPE_Embedded,					// bJackType
				JACK5_EMBIN,							// bJackID constant identifying this Jack within the function
				0,										// iJack

		// .Jack_6 = {
				USB_MIDI_OUT_JACK_DESCRIPTOR_SIZE(1),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,			// bDescriptorType
				MIDI_CS_IF_OUT_JACK,					// bDescriptorSubtype
				MIDI_JACKTYPE_External,					// bJackType
				JACK6_EXTOUT,							// bJackID
				1,										// bNrInputPins
				JACK5_EMBIN,							// baSourceID
				1,									// baSourcePin
				0, 										// iJack

		// .Jack_7 = {
				sizeof(USB_MIDI_In_Jack_Descriptor_t),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,			// bDescriptorType
				MIDI_CS_IF_IN_JACK,						// bDescriptorSubtype
				MIDI_JACKTYPE_External,					// bJackType
				JACK7_EXTIN,							// bJackID constant identifying this Jack within the function
				0,										// iJack index of a string descriptor describing this jack

		// .Jack_8 = {
				USB_MIDI_OUT_JACK_DESCRIPTOR_SIZE(1),	// bLength
				USB_CS_INTERFACE_DESCRIPTOR,			// bDescriptorType
				MIDI_CS_IF_OUT_JACK,					// bDescriptorSubtype
				MIDI_JACKTYPE_Embedded,					// bJackType
				JACK8_EMBOUT,							// bJackID
				1,										// bNrInputPins
				JACK7_EXTIN,							// baSourceID
				1,									// baSourcePin
				0,										// iJack

		// .InEP1_Desc = {
				USB_ENDPOINT_DESCSIZE,			// bLength
				USB_ENDPOINT_DESCRIPTOR,		// bDescriptorType
				0x81,							// bEndpointAddress
				USB_EPTYPE_BULK,				// bmAttributes
				htole16(SLAB_USB_EP1IN_MAX_PACKET_SIZE),	// wMaxPacketSize
				0,								// bInterval

		// .InEP1_CS_Desc = {
				USB_MIDI_CS_STREAMING_BULK_ENDPOINT_SIZE(2),	// bLength
				USB_CS_ENDPOINT_DESCRIPTOR,			// bDescriptorType
				USB_MIDI_CS_EP_MS_GENERAL,			// bDescriptorSubtype
				2,									// bNumEmbMIDIJack
				JACK4_EMBOUT, JACK8_EMBOUT, 		// baAssocJackID

		// .OutEP1_Desc = {
				USB_ENDPOINT_DESCSIZE,		// bLength
				USB_ENDPOINT_DESCRIPTOR,	// bDescriptorType
				0x01,						// bEndpointAddress
				USB_EPTYPE_BULK,			// bmAttributes
				htole16(SLAB_USB_EP1OUT_MAX_PACKET_SIZE),	// wMaxPacketSize
				0,							// bInterval

		// .OutEP1_CS_Desc = {
				USB_MIDI_CS_STREAMING_BULK_ENDPOINT_SIZE(2),	// bLength
				USB_CS_ENDPOINT_DESCRIPTOR, 					// bDescriptorType
				USB_MIDI_CS_EP_MS_GENERAL,						// bDescriptorSubtype
				2,												// bNumEmbMIDIJack
				JACK1_EMBIN, JACK5_EMBIN						// baAssocJackID

};

#define LANG_STRING   htole16( SLAB_USB_LANGUAGE )
#define MFR_STRING                                'A','S','P',' ','D','i','g','i','t','a','l','\0'
#define MFR_SIZE                                  12
#define PROD_STRING                               'U','S','B',' ','M','I','D','I','\0'
#define PROD_SIZE                                 9
#define SER_STRING                                '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','\0'
#define SER_SIZE                                  17
#define CFG_STRING                                'C','o','n','f','i','g',' ','#','1','\0'
#define CFG_SIZE                                  10
#define INT0_STRING                               'A','u','d','i','o',' ','C','o','n','t','r','o','l','\0'
#define INT0_SIZE                                 14
#define INT1_STRING                               'M','I','D','I',' ','S','t','r','e','a','m','i','n','g','\0'
#define INT1_SIZE                                 15

LANGID_STATIC_CONST_STRING_DESC( langDesc[], LANG_STRING );
UTF16LE_PACKED_STATIC_CONST_STRING_DESC( mfrDesc[], MFR_STRING, MFR_SIZE);
UTF16LE_PACKED_STATIC_CONST_STRING_DESC( prodDesc[], PROD_STRING, PROD_SIZE);
UTF16LE_PACKED_STATIC_CONST_STRING_DESC( serDesc[], SER_STRING, SER_SIZE);
UTF16LE_PACKED_STATIC_CONST_STRING_DESC( cfgDesc[], CFG_STRING, CFG_SIZE);
UTF16LE_PACKED_STATIC_CONST_STRING_DESC( int0Desc[], INT0_STRING, INT0_SIZE);
UTF16LE_PACKED_STATIC_CONST_STRING_DESC( int1Desc[], INT1_STRING, INT1_SIZE);

//-----------------------------------------------------------------------------
SI_SEGMENT_VARIABLE_SEGMENT_POINTER(myUsbStringTable_USEnglish[]
		, static const USB_StringDescriptor_TypeDef,
		SI_SEG_GENERIC,
		const SI_SEG_CODE) =
{
	(SI_VARIABLE_SEGMENT_POINTER(, uint8_t, SI_SEG_CODE))langDesc,
	mfrDesc,
	prodDesc,
	serDesc,
	cfgDesc,
	int0Desc,
	int1Desc,

};

//-----------------------------------------------------------------------------
SI_SEGMENT_VARIABLE(initstruct,
		const USBD_Init_TypeDef,
		SI_SEG_CODE) =
{
	(SI_VARIABLE_SEGMENT_POINTER(, USB_DeviceDescriptor_TypeDef, SI_SEG_GENERIC))deviceDesc, // deviceDescriptor
	(SI_VARIABLE_SEGMENT_POINTER(, USB_ConfigurationDescriptor_TypeDef, SI_SEG_GENERIC))configDesc,// configDescriptor
	(SI_VARIABLE_SEGMENT_POINTER(, USB_StringTable_TypeDef, SI_SEG_GENERIC))myUsbStringTable_USEnglish,// stringDescriptors
	sizeof(myUsbStringTable_USEnglish) / sizeof(myUsbStringTable_USEnglish[0])// numberOfStrings
};

#ifdef __cplusplus
}
#endif

